


*******************************************************
*CROSS-CUTTING CLEAVAGE--GROUP
*******************************************************

	capture program drop leb_xcut_group
	program leb_xcut_group
	version 14.0	
		syntax varlist [if]
		marksample touse, novarlist
		gettoken y : varlist
		preserve
		keep if `touse'

		
		est clear
		eststo: mi estimate, esampvaryok post: mean `y' [pweight=wgt4]	, over(T_mixed_sect T_mixed_class)
					
		estout using "$results_tables/leb_xcut_group_`y'.xls", cells(b(fmt(3))) replace title(Group Means)

		est clear

		eststo: mi estimate, post: areg   `y' group2 group3 group4 $controls_all_wgt4 [pweight=wgt4],  vce(cluster gid) absorb(strata_agg_FINAL2)  

		estout using "$results_tables/leb_xcut_group_`y'.xls", la append cells(b(fmt(%9.2f) star) se(par(`"="("'`")""') fmt(%9.2f)) p(fmt(%9.3f)) ci_l(fmt(%9.2f)) ci_u(fmt(%9.2f))) stardrop(_cons) keep(group2 group3 group4 _cons) stats(N) noomitted nobaselevel mlabels(`outcome') starl(* .10 ** .05  *** .01)
restore
end

*******************************************************
*CROSS-CUTTING CLEAVAGE ROBUSTNESS
*******************************************************

	capture program drop leb_xcut_robust
	program leb_xcut_robust
	version 14.0	
		syntax varlist [if]
		marksample touse, novarlist
		gettoken y : varlist
		preserve
		keep if `touse'

		
		est clear
		eststo: mi estimate, esampvaryok post: mean `y' [pweight=wgt1]	, over(T_mixed_sect T_mixed_class)
		eststo: mi estimate, esampvaryok post: mean `y' [pweight=wgt4]	, over(T_mixed_sect T_mixed_class)
		eststo: mi estimate, esampvaryok post: mean `y' [pweight=wgt6]	, over(T_mixed_sect T_mixed_class)
					
		estout using "$results_tables/leb_xcut_robust_`y'.xls", cells(b(fmt(3))) replace title(Group Means)

		est clear

*Results for the sample	
		eststo: mi estimate, post: reg    `y' group2 group3 group4	 						[pweight=wgt1],  vce(cluster gid)    
		eststo: mi estimate, post: reg    `y' group2 group3 group4	  $controls_all_wgt1 	[pweight=wgt1],  vce(cluster gid)

*Results for `smaller' strata		
		eststo: mi estimate, post: reg    `y' group2 group3 group4	 			 			[pweight=wgt4],  vce(cluster gid)   
		eststo: mi estimate, post: reg    `y' group2 group3 group4    $controls_all_wgt4 	[pweight=wgt4],  vce(cluster gid)
	
		eststo: mi estimate, post: areg   `y' group2 group3 group4	 			 		    [pweight=wgt4],  vce(cluster gid) absorb(strata_agg_FINAL2)    
		eststo: mi estimate, post: areg   `y' group2 group3 group4    $controls_all_wgt4 	[pweight=wgt4],  vce(cluster gid) absorb(strata_agg_FINAL2)  

*Results for `bigger' strata		
		eststo: mi estimate, post: reg    `y' group2 group3 group4	 			 			[pweight=wgt6],  vce(cluster gid)   
		eststo: mi estimate, post: reg    `y' group2 group3 group4    $controls_all_wgt6 	[pweight=wgt6],  vce(cluster gid)

		eststo: mi estimate, post: areg   `y' group2 group3 group4	 			 			[pweight=wgt6],  vce(cluster gid) absorb(strata_agg_FINAL) 
		eststo: mi estimate, post: areg   `y' group2 group3 group4    $controls_all_wgt6 	[pweight=wgt6],  vce(cluster gid) absorb(strata_agg_FINAL)
		
		estout using "$results_tables/leb_xcut_robust_`y'.xls", la append cells(b(fmt(%9.2f) star) se(par(`"="("'`")""') fmt(%9.2f)) p(fmt(%9.3f)) ci_l(fmt(%9.2f)) ci_u(fmt(%9.2f))) keep(group*) stats(N)  mlabels(`outcome') noomitted nobaselevels starl(* .10 ** .05  *** .01)
		
restore
end


*******************************************************
*CROSS-CUTTING CLEAVAGE--OLOGIT
*******************************************************


capture program drop leb_xcut_olog
	program leb_xcut_olog
	version 14.0	

	syntax varlist [if]
	marksample touse, novarlist
	gettoken y : varlist
	preserve
	keep if `touse'

	est clear
		eststo: mi estimate, post: mean `y' [pweight=wgt4]					  , over(T_mixed_sect T_mixed_class)
		
	estout using "$results_tables/leb_xcut_olog_`y'.xls", cells(b(fmt(3))) replace title(Group Means)

	est clear
	
	eststo: mi estimate, post: ologit   `y' group2 group3 group4		 			 		[pweight=wgt4], vce(cluster gid)    
	eststo: mi estimate, post: ologit   `y' group2 group3 group4	  $controls_all_wgt4 	[pweight=wgt4], vce(cluster gid)
				

	estout using "$results_tables/leb_xcut_olog_`y'.xls", la append cells(b(fmt(%9.2f) star) se(par(`"="("'`")""') fmt(%9.2f)) p(fmt(%9.3f)) ci_l(fmt(%9.2f)) ci_u(fmt(%9.2f))) keep(group*) stats(N)  mlabels(`outcome') noomitted nobaselevels starl(* .10 ** .05  *** .01)
			

restore		
end


*************************************************
*PROGRAM TO ESTIMATE MARGINAL EFFECTS
*************************************************

	capture program drop leb_xcut_margins
	program leb_xcut_margins, eclass properties(mi)
		args DV
		version 14
			est clear
			areg `DV' i.T_mixed_sect##i.T_mixed_class $controls_all_wgt4 [pweight=wgt4], absorb(strata_agg_FINAL2) vce(cluster gid)
			margins, dydx(T_mixed_sect T_mixed_class) at(T_mixed_class=(0 1) T_mixed_sect=(0 1)) atmeans post
			eststo margins
	end

	

*******************************************************
*CROSS-CUTTING CLEAVAGE--INTERACTION VERSION
*******************************************************

	capture program drop leb_xcut_int
	program leb_xcut_int
	version 14.0	
		syntax varlist [if]
		marksample touse, novarlist
		gettoken y : varlist
		preserve
		keep if `touse'
		
		est clear

		eststo: mi estimate, post: areg   `y' i.T_mixed_sect##i.T_mixed_class $controls_all_wgt4 	[pweight=wgt4],  vce(cluster gid) absorb(strata_agg_FINAL2)  

		estout using "$results_tables/leb_xcut_int_`y'.xls", replace cells(b(fmt(%9.2f) star) se(par(`"="("'`")""') fmt(%9.2f)) p(fmt(%9.3f)) ci_l(fmt(%9.2f)) ci_u(fmt(%9.2f))) stats(N) noomitted nobaselevel mlabels(`outcome') drop($controls_all_wgt4)
	
		est clear
	
		eststo: mi estimate, cmdok post: leb_xcut_margins `y'

		estout using "$results_tables/leb_xcut_int_`y'.xls", append cells(b(fmt(%9.2f) star) se(par(`"="("'`")""') fmt(%9.2f)) p(fmt(%9.3f)) ci_l(fmt(%9.2f)) ci_u(fmt(%9.2f))) stats(N) noomitted nobaselevel mlabels(`outcome') starl(* .10 ** .05  *** .01)
		
		
restore
end



*******************************************************
*HETEROGENEOUS EFFECTS
*******************************************************


capture program drop leb_xcut_het
	program leb_xcut_het
	version 14.0	

	unab varlist  : $controls_all_wgt4
	unab drop_var : $var_out
	local newlist : list varlist - drop_var

	foreach outcome in $outcomes_up {
			foreach het in $het_up {
				est clear
				
				foreach group in group2 group3 group4 {
							
				eststo: mi estimate, esampvaryok post: reg  `outcome'  `group'	 		 `newlist'		[pweight=wgt4] if `het'==0 & group1==1 | `het'==0 & `group'==1, vce(cluster gid)    
				eststo: mi estimate, esampvaryok post: reg  `outcome'  `group'	 		 `newlist'		[pweight=wgt4] if `het'==1 & group1==1 | `het'==1 & `group'==1, vce(cluster gid)    
				eststo: mi estimate, esampvaryok post: reg  `outcome'  `group'##i.`het'	 `newlist'		[pweight=wgt4] if group1==1 | `group'==1, vce(cluster gid)    
				
				}
						
				estout using "$results_tables/leb_diag_xcut_`het'_`outcome'.xls", la replace cells(b(fmt(%9.2f) star) se(par(`"="("'`")""') fmt(%9.2f)) p(fmt(%9.3f))) stardrop(_cons) noomitted nobaselevels drop(`newlist') starl(* .10 ** .05  *** .01) stats(N_mi)  mlabels(`outcome') 
			}
		   }	
end








	
	
	
	
	
	
	
	
